# This is a hack to prevent the RPM from depending on libGLcore.so.1 and
# libnvidia-tls.so.1 if it was built on a system that has the NVidia
# drivers installed.  The custom find-requires script is created during
# install and removed during clean

%define __find_requires %{_tmppath}/%{name}-%{version}-%{release}-find-requires

Summary: A toolkit for displaying OpenGL applications to thin clients
Name: VirtualGL
Version: %{_version}
Vendor: The VirtualGL Project
URL: http://www.virtualgl.org
Group: Applications/Graphics
#-->Source0: http://prdownloads.sourceforge.net/virtualgl/VirtualGL-%{version}.tar.gz
Release: %{_build}
License: wxWindows Library License v3.1
BuildRoot: %{_blddir}/%{name}-buildroot-%{version}-%{release}
Prereq: /sbin/ldconfig, /usr/bin/perl
Provides: %{name} = %{version}-%{release}

%description
VirtualGL is a library which allows most Linux OpenGL applications to be
remotely displayed to a thin client without the need to alter the
applications in any way.  VGL inserts itself into an application at run time
and intercepts a handful of GLX calls, which it reroutes to the server's
display (which presumably has a 3D accelerator attached.)  This causes all
3D rendering to occur on the server's display.  As each frame is rendered
by the server, VirtualGL reads back the pixels from the server's framebuffer
and sends them to the client for re-compositing into the appropriate X
Window.  VirtualGL can be used to give hardware-accelerated 3D capabilities to
VNC or other remote display environments that lack GLX support.  In a LAN
environment, it can also be used with its built-in motion-JPEG video delivery
system to remotely display full-screen 3D applications at 20+ frames/second.

VirtualGL is based upon ideas presented in various academic papers on
this topic, including "A Generic Solution for Hardware-Accelerated Remote
Visualization" (Stegmaier, Magallon, Ertl 2002) and "A Framework for
Interactive Hardware Accelerated Remote 3D-Visualization" (Engel, Sommer,
Ertl 2000.)

#-->%prep
#-->%setup -q -n vgl

#-->%build
#-->make DISTRO=
#-->%ifarch x86_64
#-->make M32=yes DISTRO=
#-->%endif

%install

rm -rf $RPM_BUILD_ROOT

make install prefix=$RPM_BUILD_ROOT/usr

mkdir -p $RPM_BUILD_ROOT/opt/%{name}/bin
for i in tcbench nettest cpustat glxinfo glxspheres; do
	mv $RPM_BUILD_ROOT/usr/bin/$i $RPM_BUILD_ROOT/opt/%{name}/bin/
done
%ifarch x86_64
mv $RPM_BUILD_ROOT/usr/bin/glxspheres64 $RPM_BUILD_ROOT/opt/%{name}/bin/
%endif
pushd $RPM_BUILD_ROOT/usr/bin
for i in *; do ln -fs /usr/bin/$i $RPM_BUILD_ROOT/opt/%{name}/bin/; done
popd

rm -rf $RPM_BUILD_ROOT/usr/fakelib
mkdir -p $RPM_BUILD_ROOT/opt/%{name}/fakelib
%ifarch x86_64
mkdir -p $RPM_BUILD_ROOT/opt/%{name}/fakelib/64
%endif
ln -fs /usr/lib/librrfaker.so $RPM_BUILD_ROOT/opt/%{name}/fakelib/libGL.so
%ifarch x86_64
ln -fs /usr/lib64/librrfaker.so $RPM_BUILD_ROOT/opt/%{name}/fakelib/64/libGL.so
%endif

mkdir -p $RPM_BUILD_ROOT/opt/%{name}/include
ln -fs /usr/include/rrtransport.h $RPM_BUILD_ROOT/opt/%{name}/include/rrtransport.h
ln -fs /usr/include/rr.h $RPM_BUILD_ROOT/opt/%{name}/include/rr.h

rm -rf $RPM_BUILD_ROOT/usr/doc
ln -fs /usr/share/doc/%{name}-%{version} $RPM_BUILD_ROOT/opt/%{name}/doc
cp fltk/COPYING LICENSE-FLTK.txt
cp putty/LICENCE LICENSE-PuTTY.txt
cp x11windows/xauth.license LICENSE-xauth.txt
chmod 644 LGPL.txt LICENSE.txt LICENSE-FLTK.txt LICENSE-PuTTY.txt LICENSE-xauth.txt ChangeLog.txt doc/index.html doc/*.png doc/*.gif doc/*.css

echo '/usr/lib/rpm/find-requires|grep -v libGLcore|grep -v libnvidia-tls' >%{_tmppath}/%{name}-%{version}-%{release}-find-requires
chmod 755 %{_tmppath}/%{name}-%{version}-%{release}-find-requires

%clean
rm -rf $RPM_BUILD_ROOT
rm %{_tmppath}/%{name}-%{version}-%{release}-find-requires

%post
/sbin/ldconfig

%postun
/sbin/ldconfig

%files -n %{name}
%defattr(-,root,root)
%doc LGPL.txt LICENSE.txt LICENSE-FLTK.txt LICENSE-PuTTY.txt LICENSE-xauth.txt ChangeLog.txt doc/index.html doc/*.png doc/*.gif doc/*.css

%dir /opt/%{name}
%dir /opt/%{name}/bin
%dir /opt/%{name}/fakelib
%ifarch x86_64
%dir /opt/%{name}/fakelib/64
%endif
%dir /opt/%{name}/include

/usr/bin/vglclient
/usr/bin/vglconfig
/usr/bin/vglconnect
/usr/bin/vgllogin
/usr/bin/vglrun
/usr/bin/vglgenkey
/usr/bin/vglserver_config

/opt/%{name}/bin/tcbench
/opt/%{name}/bin/nettest
/opt/%{name}/bin/cpustat
/opt/%{name}/bin/glxinfo
/opt/%{name}/bin/vglclient
/opt/%{name}/bin/vglconfig
/opt/%{name}/bin/vglconnect
/opt/%{name}/bin/vglgenkey
/opt/%{name}/bin/vgllogin
/opt/%{name}/bin/vglserver_config
/opt/%{name}/bin/vglrun
/opt/%{name}/bin/glxspheres

/opt/%{name}/fakelib/libGL.so
%ifarch x86_64
/opt/%{name}/fakelib/64/libGL.so
%endif
/opt/%{name}/doc

/opt/%{name}/include/rrtransport.h
/opt/%{name}/include/rr.h

/usr/lib/librrfaker.so
/usr/lib/libdlfaker.so
/usr/lib/libgefaker.so
%ifarch x86_64
/usr/lib64/librrfaker.so
/usr/lib64/libdlfaker.so
/usr/lib64/libgefaker.so
/opt/%{name}/bin/glxspheres64
%endif
/usr/include/rrtransport.h
/usr/include/rr.h

%changelog
